sc::ActiveMsgMemoryGrp(3)

NAME
sc::ActiveMsgMemoryGrp - The ActiveMsgMemoryGrp abstract class specializes the MsgMemoryGrp class.

SYNOPSIS

#include <memamsg.h>

Inherits sc::MsgMemoryGrp.

Inherited by sc::MTMPIMemoryGrp.

  Public Member Functions
ActiveMsgMemoryGrp (const Ref< MessageGrp > &msg)
ActiveMsgMemoryGrp (const Ref< KeyVal > &)
void set_localsize (size_t)
Set the size of locally held memory.
void * localdata ()
Returns a pointer to the local data.
void * obtain_writeonly (distsize_t offset, int size)
This gives write access to the memory location. No locking is done.
void * obtain_readwrite (distsize_t offset, int size)
Only one thread can have an unreleased obtain_readwrite at a time.
void * obtain_readonly (distsize_t offset, int size)
This gives read access to the memory location. No locking is done.
void release_readonly (void *data, distsize_t offset, int size)
This is called when read access is no longer needed.
void release_writeonly (void *data, distsize_t offset, int size)
This is called when write access is no longer needed.
void release_readwrite (void *data, distsize_t offset, int size)
This is called when read/write access is no longer needed.
void sum_reduction (double *data, distsize_t doffset, int dsize)
void sum_reduction_on_node (double *data, size_t doffset, int dsize, int node=-1)
void print (std::ostream &o=ExEnv::out0()) const
Prints out information about the object.

  Protected Member Functions
virtual void retrieve_data (void *, int node, int offset, int size, int lock)=0
virtual void replace_data (void *, int node, int offset, int size, int unlock)=0
virtual void sum_data (double *data, int node, int doffset, int dsize)=0

  Protected Attributes
char * data_

Detailed Description

The ActiveMsgMemoryGrp abstract class specializes the MsgMemoryGrp class. It uses active messages to implement global shared memory.

Member Function Documentation

  void sc::ActiveMsgMemoryGrp::set_localsize (size_t) [virtual]

Set the size of locally held memory.

When memory is accessed using a global offset counting starts at node 0 and proceeds up to node n() - 1.

Reimplemented from sc::MsgMemoryGrp.

  void* sc::ActiveMsgMemoryGrp::obtain_readwrite (distsize_t offset, int size) [virtual]

Only one thread can have an unreleased obtain_readwrite at a time.

The actual memory region locked can be larger than that requested. If the memory region is already locked this will block. For this reason, data should be held as read/write for as short a time as possible.

Implements sc::MemoryGrp.

  void sc::ActiveMsgMemoryGrp::release_readwrite (void * data, distsize_t offset, int size) [virtual]

This is called when read/write access is no longer needed.

The memory will be unlocked.

Implements sc::MemoryGrp.

Author

Generated automatically by Doxygen for MPQC from the source code.